<?php

require_once 'base/RelacionaparcEntityBase.php';

/**
 * This class has been auto-generated by Setforms
 * 
 * @package Entity
 * 
 * @author  cristianefaria
 */
class RelacionaparcEntity extends RelacionaparcEntityBase
{

	  /**
     * retorna um objeto da classe RelacionaparcEntity.
     *
     * @return RelacionaparcEntity
     *
     * @author gustavosilva - 23/05/2012
     */
	public static function consultaInterlocutorParcnegocio($nrparcnegocio, $nrorg){
	    try{
		return Relacionaparc::consultaInterlocutorParcnegocio($nrparcnegocio, $nrorg);
            } catch (Exception $e) {
                throw $e;
            }	
	}
	
	 /**
     * retorna um array de objetos da classe RelacionaparcEntity.
     *
     * @return array
     *
     * @author gustavosilva - 23/05/2012
     */
	public static function getRelacionamentoByWhere($where, $params){
	
	try{

		return Relacionaparc::getRelacionamentoByWhere($where, $params);
		}catch(Exception $e){
			throw $e;
		}
		
	}   
	/**
     * Deleta o interlocutor com base no nrparcnegocio.
     *
     * @param integer $nrparcnegocio Numero do Parceiro de Negócio
     * @param integer $nrorg 		Numero da Organização
     *
     * @return void
     *
     * @author gustavosilva - 23/05/2012
     */
	public static function deleteInterlocutorFromNrparcnegocio($nrparcnegocio, $nrorg){
		
		Relacionaparc::deleteInterlocutorFromNrparcnegocio($nrparcnegocio, $nrorg);
		
	}
	

	/**
     * Cria um novo registro de interlocutor.
     *
     * @param integer $nrparcnegocio	  	Numero do Parceiro de Negócio
     * @param integer $nrparcnegrelac 	Numero do Parceiro de Relacionamento
     * @param integer $nrorg				Numero da Organização
     *
     * @return void
     *
     * @author gustavosilva - 23/05/2012
     */
	public static function createNewInterlocutor($nrparcnegocio, $nrparcnegrelac, $nrorg){

		try{
			$interlocutor = new self();
			$interlocutor->setNrrelacionaparc(Novocodigo::geraCodigo(Ambiente::getNrorg(), 'RELACIONAPARC', 4));
			$interlocutor->setNrparcnegrelac($nrparcnegocio);
			$interlocutor->setNrparcnegocio($nrparcnegrelac);
			$interlocutor->setNrtiporelaciona('25');
			$interlocutor->setNrorg($nrorg);
			$interlocutor->setIdativo('S');
			FctUtil::newEntityAudit($interlocutor);
			$interlocutor->persist();
		}catch(Exception $e){
			throw $e;
		}
	}
	

	/**
     * Deleta os filhos da tabela Relacionaparc.
     *
     * @return void
     *
     * @author gustavosilva - 23/05/2012
     */
	public static function deleteChild($nrparcnegocio, $nrorg, $identificador){
		
		try{
                    Relacionaparc::deleteChild($nrparcnegocio, $nrorg, $identificador);
                }catch(Exception $e){
                    throw $e;
                }
		 
	}

    public static function consultaInterlocutorDoParceiro($nrParcNegocio, $nrOrg){

        $dadosInterloc = Relacionaparc::consultaInterlocutorDoParceiro($nrParcNegocio, $nrOrg);
        if(is_object($dadosInterloc)) {
            return $dadosInterloc;
        }
    }

    public function insereRelacionaParceiro($nrorg, $nrparcnegocio, $nrparcnegrelac, $nrtiporelaciona, $idativo)
    {
        $this->setNrorg($nrorg);
        $this->setNrparcnegocio($nrparcnegocio);
        $this->setNrparcnegrelac($nrparcnegrelac);
        $this->setNrtiporelaciona($nrtiporelaciona);
        $this->setIdativo($idativo);
    }

}

