CREATE OR REPLACE TRIGGER LOG_GER_PRODRETI
AFTER UPDATE OR INSERT OR DELETE
ON PRODRETI FOR EACH ROW
DECLARE
  V_TIPO         VARCHAR2(1);
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_CDFILLOGOPER VARCHAR2(4);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
BEGIN
   /*IDTIPOOPER - '1' - Incluso,
                  '2' - Alterao,
                  '3' - Excluso*/

   V_TIPO         := '0';
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_CDFILLOGOPER := '';

   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF DELETING THEN
      IF :OLD.CDTIPORETI IS NOT NULL THEN
         V_DESC := V_DESC || ' TipoReti=' || :OLD.CDTIPORETI;
      END IF;

      IF :OLD.CDPRODRETI IS NOT NULL THEN
         V_DESC := V_DESC || ' Produto=' || :OLD.CDPRODRETI;
      END IF;

      V_TIPO   := '3';
      V_ITPESQ := :OLD.CDTIPORETI||:OLD.CDPRODRETI;
   ELSE
      IF UPDATING THEN
         IF (NVL(:OLD.CDTIPORETI,'!') <> NVL(:NEW.CDTIPORETI,'!')) OR
            (NVL(:OLD.CDPRODRETI,'!') <> NVL(:NEW.CDPRODRETI,'!')) THEN

            IF NVL(:NEW.CDTIPORETI, '!') <> NVL(:OLD.CDTIPORETI, '!') THEN
               V_DESC := V_DESC||' TipoReti='  || :NEW.CDTIPORETI;
            END IF;

            IF :NEW.CDPRODRETI <> :OLD.CDPRODRETI THEN
               V_DESC := V_DESC||' Produto='  || :NEW.CDPRODRETI;
            END IF;

            V_TIPO   := '2';
            V_ITPESQ := :OLD.CDTIPORETI||:OLD.CDPRODRETI;
         END IF;
      ELSE
         IF NVL(:NEW.CDTIPORETI, '!') <> NVL(:OLD.CDTIPORETI, '!') THEN
            V_DESC := V_DESC||' TipoReti='  || :NEW.CDTIPORETI;
         END IF;

         IF NVL(:NEW.CDPRODRETI, '!') <> NVL(:OLD.CDPRODRETI, '!') THEN
            V_DESC := V_DESC||' Produto='  || :NEW.CDPRODRETI;
         END IF;

         V_TIPO   := '1';
         V_ITPESQ := :NEW.CDTIPORETI||:NEW.CDPRODRETI;
      END IF;
   END IF;

   V_DESC := SUBSTR(V_DESC, 1, 400);

   IF V_TIPO <> '0' THEN
      IF NOT V_DESC IS NULL THEN
         INSERT INTO LOGOPERA
            (NMTABELA,
             DTOPERACAO,
             NMRESPOPER,
             IDTIPOOPER,
             DSOPERACAO,
             CDPESQITEM,
             DSRDMUSUOPER,
             DSENDUSUOPER,
             DSNMUSUOPER,
             DSMETUSUOPER,
             CDORESPOPER,
             CDFILLOGOPER)
         VALUES
            ('PRODRETI',
             SYSDATE,
             NVL(V_NMOPERADOR,' '),
             V_TIPO,
             V_DESC,
             V_ITPESQ,
             V_DSSERVERRDM,
             V_DSREMOTEADDR,
             V_DSREMOTEHOST,
             V_DSSERVMETHOD,
             V_DSREMOTEOPER,
             V_CDFILLOGOPER);
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_GER_PRODRETI','6.05.XXX'); END;
/
