CREATE OR REPLACE TRIGGER ATUALIZA_RESERVA_PEDIDOOL
AFTER UPDATE OF QTPROGENPEOL, QTATENDPEDOL
ON ITEMPEDEXOL FOR EACH ROW
DECLARE
   V_FILOPELOG VARCHAR2(4);
   V_DTPROGEMBARQ DATE;
   V_QUANT_ESTOQUE FLOAT;
   V_ESTOQ_RESERVADO FLOAT;
   V_ESTOQUE_TOTAL FLOAT;
   V_RESERVA FLOAT;
   V_ITEM_RESERVA FLOAT := 0;
   V_CDFILIOLAGETERC      FILIAL.CDFILIAL%TYPE;
BEGIN
   SELECT NVL(MAX(QTRESERVESTOL), 0)
     INTO V_ITEM_RESERVA
     FROM RESERVAPEDEXOL
    WHERE CDFILDEST    = NVL(:NEW.CDFILDEST, :OLD.CDFILDEST)
      AND CDFILLANC    = NVL(:NEW.CDFILLANC, :OLD.CDFILLANC)
      AND NRPEDEXOL    = NVL(:NEW.NRPEDEXOL, :OLD.NRPEDEXOL)
      AND CDMARCA      = NVL(:NEW.CDMARCA, :OLD.CDMARCA)
      AND CDPRODUTO    = NVL(:NEW.CDPRODUTO, :OLD.CDPRODUTO)
      AND DTPROGENPEOL = NVL(:NEW.DTPROGENPEOL, :OLD.DTPROGENPEOL);
   IF V_ITEM_RESERVA > 0 THEN
      V_DTPROGEMBARQ := NVL(:NEW.DTPROGEMBARQ, :OLD.DTPROGEMBARQ);
      SELECT CDFILIOPELOG
        INTO V_FILOPELOG
        FROM PEDIDOEXOL
       WHERE CDFILDEST    = :NEW.CDFILDEST
         AND CDFILLANC    = :NEW.CDFILLANC
         AND NRPEDEXOL    = :NEW.NRPEDEXOL;

      SELECT NVL(MAX(CDFILIAL), '')
        INTO V_CDFILIOLAGETERC
        FROM FILIAL
       WHERE CDFILIOLAGETERC = V_FILOPELOG;
      IF (((V_CDFILIOLAGETERC  = '') AND (:NEW.QTPROGENPEOL) <> (:OLD.QTPROGENPEOL)) OR ((:NEW.QTPROGENPEOL) <> (:OLD.QTPROGENPEOL))) THEN
         SELECT CALC_ESTOQ_CONS(MAX(V_FILOPELOG), DECODE (MAX(R.CDPRODARVOL), MAX(P.CDPRODESTO), MAX(R.CDPRODARVOL), MAX(PR.CDPRODUTO)), MAX(TRUNC(SYSDATE) + 1))
           INTO V_QUANT_ESTOQUE
           FROM RELACPRODOL R, PRODUTO P, PRODUTO PR
          WHERE P.CDPRODUTO   = R.CDPRODARVOL
            AND P.CDPRODESTO  = PR.CDPRODUTO
            AND R.CDPRARVORIG = NVL(:NEW.CDPRODUTO, :OLD.CDPRODUTO)
            AND R.CDMARCA     = NVL(:NEW.CDMARCA, :OLD.CDMARCA);

         SELECT SUM(QTRESERVESTOL)
           INTO V_ESTOQ_RESERVADO
           FROM RESERVAPEDEXOL
          WHERE CDPRODUTO    =  NVL(:NEW.CDPRODUTO, :OLD.CDPRODUTO)
            AND CDMARCA      =  NVL(:NEW.CDMARCA, :OLD.CDMARCA)
            AND CDFILRESOL   =  V_FILOPELOG
            AND (CDFILDEST   <> NVL(:NEW.CDFILDEST, :OLD.CDFILDEST)
             OR CDFILLANC    <> NVL(:NEW.CDFILLANC, :OLD.CDFILLANC)
             OR NRPEDEXOL    <> NVL(:NEW.NRPEDEXOL, :OLD.NRPEDEXOL)
             OR DTPROGENPEOL <> NVL(:NEW.DTPROGENPEOL, :OLD.DTPROGENPEOL));
         V_RESERVA := NVL(:NEW.QTATENDPEDOL, :NEW.QTPROGENPEOL);
         V_ESTOQUE_TOTAL := NVL(V_QUANT_ESTOQUE, 0) - (NVL(V_ESTOQ_RESERVADO, 0) + V_RESERVA);
         IF V_ESTOQUE_TOTAL >= 0 THEN
            UPDATE RESERVAPEDEXOL
               SET QTRESERVESTOL = NVL(:NEW.QTATENDPEDOL, :NEW.QTPROGENPEOL)
             WHERE CDFILDEST    = :NEW.CDFILDEST
               AND CDFILLANC    = :NEW.CDFILLANC
               AND NRPEDEXOL    = :NEW.NRPEDEXOL
               AND CDMARCA      = :NEW.CDMARCA
               AND CDPRODUTO    = :NEW.CDPRODUTO
               AND DTPROGENPEOL = :NEW.DTPROGENPEOL;
            IF SQL%NOTFOUND THEN
               INSERT INTO RESERVAPEDEXOL
                  (CDFILDEST, CDFILLANC, NRPEDEXOL, CDPRODUTO, CDMARCA,
                   DTPROGENPEOL, QTRESERVESTOL, CDFILRESOL, DTRESEMBARQ)
               VALUES
                  (:NEW.CDFILDEST, :NEW.CDFILLANC, :NEW.NRPEDEXOL, :NEW.CDPRODUTO, :NEW.CDMARCA,
                   :NEW.DTPROGENPEOL, V_RESERVA, V_FILOPELOG, V_DTPROGEMBARQ);
            END IF;
         ELSE
            DELETE
              FROM RESERVAPEDEXOL
             WHERE CDFILDEST    = :NEW.CDFILDEST
               AND CDFILLANC    = :NEW.CDFILLANC
               AND NRPEDEXOL    = :NEW.NRPEDEXOL
               AND CDMARCA      = :NEW.CDMARCA
               AND CDPRODUTO    = :NEW.CDPRODUTO
               AND DTPROGENPEOL = :NEW.DTPROGENPEOL;
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZA_RESERVA_PEDIDOOL','5.30.XXX'); END;
/
