<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\Repositories;

class EsoNaoperiodico extends \Doctrine\ORM\EntityRepository {
    
    public function getEnviosPorNomeEvento($nrorg, $nmevento, $nrestruturam, $nrtpambiente, $idativo = 'S', $nrchave = null, $nrtabela = null, $idoperacao = null, $nrenvioexcl = null) {
        try{
            $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
            $params = array(
                'P_NRORG'        => $nrorg,
                'P_NMEVENTO'     => $nmevento,
                'P_NRESTRUTURAM' => $nrestruturam,
                'P_NRTPAMBIENTE' => $nrtpambiente,
                'P_IDATIVO'      => $idativo,
                'P_NRCHAVE'      => $nrchave,
                'P_NRTABELA'     => $nrtabela,
                'P_IDOPERACAO'   => $idoperacao,
                'P_NRENVIOEXCL'  => $nrenvioexcl
            );
            $sql = "SELECT EC.*
                      FROM ESO_ENVIOCADASTROS EC
                      JOIN ESO_EVENTO EV ON EV.NREVENTO = EC.NREVENTO
                     WHERE EC.NRORG = :P_NRORG
                       AND EV.NMEVENTO = :P_NMEVENTO
                       AND EC.NRESTRUTURAM = :P_NRESTRUTURAM
                       AND EC.NRTPAMBIENTE = :P_NRTPAMBIENTE
                       AND EC.IDATIVO = :P_IDATIVO
                       AND EC.NRENVIOEXCL IS NULL
                       AND (EC.NRCHAVE = :P_NRCHAVE OR :P_NRCHAVE IS NULL)
                       AND (EC.NRTABELA = :P_NRTABELA OR :P_NRTABELA IS NULL)
                       AND ((:P_NRENVIOEXCL = 'S' AND EC.NRENVIOEXCL IS NOT NULL) OR (:P_NRENVIOEXCL = 'N' AND EC.NRENVIOEXCL IS NULL) OR :P_NRENVIOEXCL IS NULL)
                       AND (EC.IDOPERACAO = :P_IDOPERACAO OR :P_IDOPERACAO IS NULL)";
           
            return $db->fetchAssoc($sql, $params);
        } catch (Exception $e) {
            throw $e;
        }
    }
        
    public function getEnviosPorNomeEventoChave($nrorg, $nmevento, $nrchave, $nrtpambiente, $idativo = 'S', $nrestruturam = null, $nrtabela = null, $idoperacao = null, $nrenvioexcl = null) {
        try{
            $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
            $params = array(
                'P_NRORG'        => $nrorg,
                'P_NMEVENTO'     => $nmevento,
                'P_NRESTRUTURAM' => $nrestruturam,
                'P_NRTPAMBIENTE' => $nrtpambiente,
                'P_IDATIVO'      => $idativo,
                'P_NRCHAVE'      => $nrchave,
                'P_NRTABELA'     => $nrtabela,
                'P_IDOPERACAO'   => $idoperacao,
                'P_NRENVIOEXCL'  => $nrenvioexcl
            );
            $sql = "SELECT EC.*
                      FROM ESO_ENVIOCADASTROS EC
                      JOIN ESO_EVENTO EV ON EV.NREVENTO = EC.NREVENTO
                     WHERE EC.NRORG = :P_NRORG
                       AND INSTR(','||:P_NMEVENTO||',', ','||EV.NMEVENTO||',') > 0 
                       AND EC.NRCHAVE = :P_NRCHAVE
                       AND EC.NRTPAMBIENTE = :P_NRTPAMBIENTE
                       AND EC.IDATIVO = :P_IDATIVO
                       AND EC.NRENVIOEXCL IS NULL
                       AND (EC.NRESTRUTURAM = :P_NRESTRUTURAM OR :P_NRESTRUTURAM IS NULL)
                       AND (EC.NRTABELA = :P_NRTABELA OR :P_NRTABELA IS NULL)
                       AND ((:P_NRENVIOEXCL = 'S' AND EC.NRENVIOEXCL IS NOT NULL) OR (:P_NRENVIOEXCL = 'N' AND EC.NRENVIOEXCL IS NULL) OR :P_NRENVIOEXCL IS NULL)
                       AND (EC.IDOPERACAO = :P_IDOPERACAO OR :P_IDOPERACAO IS NULL)";
           
            return $db->fetchAssoc($sql, $params);
        } catch (Exception $e) {
            throw $e;
        }
    }
    
     public function getEnviosPorNomeEventoChaveCnpj($nrorg, $nmevento, $nrchave, $nrtpambiente, $cdcnpjestrut, $dtmescompetenc, $idativo = 'S',  $nrtabela = null, $idoperacao = null, $nrenvioexcl = null) {
        try{
            $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
            $params = array(
                'P_NRORG'          => $nrorg,
                'P_NMEVENTO'       => $nmevento,
                'P_CDCNPJESTRUT'   => $cdcnpjestrut,
                'P_NRTPAMBIENTE'   => $nrtpambiente,
                'P_IDATIVO'        => $idativo,
                'P_NRCHAVE'        => $nrchave,
                'P_NRTABELA'       => $nrtabela,
                'P_IDOPERACAO'     => $idoperacao,
                'P_NRENVIOEXCL'    => $nrenvioexcl,
                'P_DTMESCOMPETENC' => $dtmescompetenc
            );
            $sql = "SELECT EC.*
                      FROM ESO_ENVIOCADASTROS EC
                      JOIN ESO_EVENTO EV ON EV.NREVENTO = EC.NREVENTO
                      JOIN ESTRUTURAH EH ON EH.NRESTRUTURAM = EC.NRESTRUTURAM
                                         AND EH.NRORG = EC.NRORG
                                         AND SUBSTR(EH.CDCNPJESTRUT,1,8) = SUBSTR(:P_CDCNPJESTRUT,1,8)
                                         AND EH.DTMESCOMPETENC = (SELECT MAX(EHH.DTMESCOMPETENC)
                                                                    FROM ESTRUTURAH EHH
                                                                   WHERE EHH.NRORG = EH.NRORG
                                                                     AND EHH.NRESTRUTURAM = EH.NRESTRUTURAM
                                                                     AND EHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                     WHERE EC.NRORG = :P_NRORG
                       AND INSTR(','||:P_NMEVENTO||',', ','||EV.NMEVENTO||',') > 0 
                       AND EC.NRCHAVE = :P_NRCHAVE
                       AND EC.NRTPAMBIENTE = :P_NRTPAMBIENTE
                       AND EC.IDATIVO = :P_IDATIVO
                       AND EC.NRENVIOEXCL IS NULL
                       AND (EC.NRTABELA = :P_NRTABELA OR :P_NRTABELA IS NULL)
                       AND ((:P_NRENVIOEXCL = 'S' AND EC.NRENVIOEXCL IS NOT NULL) OR (:P_NRENVIOEXCL = 'N' AND EC.NRENVIOEXCL IS NULL) OR :P_NRENVIOEXCL IS NULL)
                       AND (EC.IDOPERACAO = :P_IDOPERACAO OR :P_IDOPERACAO IS NULL)";
           
            return $db->fetchAssoc($sql, $params);
        } catch (Exception $e) {
            throw $e;
        }
    }

    public function getEnviosEvento($nrorg, $nmevento, $nrestruturam, $nrtpambiente, $idativo = 'S', $nrchave = null, $idoperacao = array(), $nrenvioexcl=null) {
        try{
            $esoNaoperiodico = Repositories::ESO_NAOPERIODICO;
            $esoEvento = Repositories::ESO_EVENTO;
            
            $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
            $params = array(
                'nrorg' => $nrorg,
                'nmevento' => $nmevento,
                'nrestruturam' => $nrestruturam,
                'nrtpambiente' => $nrtpambiente,
                'idativo' => $idativo,
                'nrchave' => $nrchave,
                'nrenvioexcl' => $nrenvioexcl,
            );
            $sql = "SELECT envio
                      FROM $esoNaoperiodico envio
                     WHERE envio.nrorg = :nrorg
                       AND envio.nmevento = :nmevento
                       AND (envio.nrestruturam = :nrestruturam OR (envio.nrestruturam <> :nrestruturam AND envio.nmevento IN ('S-2205','S-2206','S-2306'))) 
                       AND envio.nrtpambiente = :nrtpambiente
                       AND envio.idativo = :idativo
                       AND envio.nrenvioexcl IS NULL
                       AND (envio.nrchave = :nrchave OR :nrchave IS NULL)
                       AND ((:nrenvioexcl = 'S' AND envio.nrenvioexcl IS NOT NULL) OR (:nrenvioexcl = 'N' AND envio.nrenvioexcl IS NULL) OR :nrenvioexcl IS NULL)";
            
            if (!empty($idoperacao)) {
                $sql .= " AND (envio.idoperacao IN ('".implode("','",$idoperacao)."'))";
            }
           
            return $this->getEntityManager()->createQuery($sql)->execute($params);
        } catch (Exception $e) {
            throw $e;
        }
    }
}